// Author:       Andreas F. Borchert
// Description:  template class for stacks that are based
//               on arrays of a given length

#include "ArrayedStack.h"
#include "StackExceptions.h"

template<class Item>
ArrayedStack<Item>::ArrayedStack() :
      index(0)
{
} // default constructor

template<class Item>
bool ArrayedStack<Item>::empty() const {
   return index == 0;
} // empty

template<class Item>
bool ArrayedStack<Item>::full() const {
   return index == SIZE;
} // full

template<class Item>
const Item& ArrayedStack<Item>::top() const throw(EmptyStack) {
   if (index > 0) {
      return items[index-1];
   } else {
      throw EmptyStack();
   }
} // top

template<class Item>
void ArrayedStack<Item>::push(const Item& item) throw(FullStack) {
   if (index < SIZE) {
      items[index] = item;
      index += 1;
   } else {
      throw FullStack();
   }
} // push

template<class Item>
void ArrayedStack<Item>::pop() throw(EmptyStack) {
   if (index > 0) {
      index -= 1;
   } else {
      throw EmptyStack();
   }
} // pop
