// Author:       Andreas F. Borchert
// Description:  template class for stacks that are based
//               on arrays of a given length

#ifndef ARRAYED_STACK_H
#define ARRAYED_STACK_H

#include "Stack.h"
#include "StackExceptions.h"

template<class Item>
class ArrayedStack: public Stack<Item> {
   public:
      // constructors and destructors
      ArrayedStack();

      // accessors
      virtual bool empty() const;
      virtual bool full() const;
      virtual const Item& top() const throw(EmptyStack);
	 // PRE: not empty()

      // mutators
      virtual void push(const Item& item) throw(FullStack);
	 // PRE: not full()
      virtual void pop() throw(EmptyStack);
	 // PRE: not empty()
   private:
      static const int SIZE = 4;
      int index;
      Item items[SIZE];
}; // class ArrayedStack

#endif
