// Author:       Andreas F. Borchert
// Description:  RPN calculator

#ifndef CALCULATOR_H
#define CALCULATOR_H

#include <string>
#include "Stack.h"
#include "CalculatorExceptions.h"

class Calculator {
   public:
      typedef Stack<float> FloatStack;

      // constructor
      Calculator(FloatStack& stack);

      float calculate(const std::string& expr) throw(CalculatorException);
	 // PRE: expr in RPN (reversed polish notation) syntax
   private:
      FloatStack& opstack;
}; // class Calculator

#endif
