// Author:       Andreas F. Borchert
// Description:  RPN calculator exceptions

#ifndef CALCULATOR_EXCEPTIONS_H
#define CALCULATOR_EXCEPTIONS_H

#include <exception>

class CalculatorException : public std::exception {};

class SyntaxError : public CalculatorException {
   public:
      virtual const char* what() const throw() {
	 return "syntax error";
      };
}; // class SyntaxError

class BadExpr : public CalculatorException {
   public:
      virtual const char* what() const throw() {
	 return "invalid expression";
      };
}; // class BadExpr

class StackFailure : public CalculatorException {
   public:
      virtual const char* what() const throw() {
	 return "stack failure";
      };
}; // class StackFailure

#endif
