// Author:       Andreas F. Borchert
// Description:  abstract stack template class

#ifndef STACK_H
#define STACK_H

#include "StackExceptions.h"

template<class Item>
class Stack {
   public:
      // destructor
      virtual ~Stack() {};

      // accessors
      virtual bool empty() const = 0;
      virtual bool full() const = 0;
      virtual const Item& top() const throw(EmptyStack) = 0;
	 // PRE: not empty()

      // mutators
      virtual void push(const Item& item) throw(FullStack) = 0;
	 // PRE: not full()
      virtual void pop() throw(EmptyStack) = 0;
	 // PRE: not empty()
}; // class Stack

#endif
